//+------------------------------------------------------------------+
//|                                                  Pj-over RSI.mq4 |
//|                                      Copyright  2007, PRIMAjaya |
//|                                   http://primaforex.blogspot.com |
//| tools added mtf and alerts and a little improve                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, PRIMAjaya"
#property link      "http://primaforex.blogspot.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  DarkGreen
#property indicator_color2  Red
#property indicator_color3  MediumSeaGreen
#property indicator_color4  Tomato
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    Price           = 0;
extern int    RsiPeriod       = 14;
extern int    OverboughtLevel = 70;
extern int    OversoldLevel   = 30;

extern bool   alertsOn        = true;
extern bool   alertsOnObOs    = false;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

//
//
//
//
//

double UpH1[];
double DnH1[];
double UpH2[];
double DnH2[];
double rsi[];
double trend1[];
double trend2[];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{

   IndicatorBuffers(7);
   SetIndexBuffer(0,UpH1);   SetIndexStyle(0,DRAW_HISTOGRAM); SetIndexLabel(0,"Overbought or Strong Bulls");
   SetIndexBuffer(1,DnH1);   SetIndexStyle(1,DRAW_HISTOGRAM); SetIndexLabel(1,"Oversold or Strong Bears");
   SetIndexBuffer(2,UpH2);   SetIndexStyle(2,DRAW_HISTOGRAM); SetIndexLabel(2,"Trend Bulls");
   SetIndexBuffer(3,DnH2);   SetIndexStyle(3,DRAW_HISTOGRAM); SetIndexLabel(3,"Trend Bears");
   SetIndexBuffer(4,rsi);
   SetIndexBuffer(5,trend1);
   SetIndexBuffer(6,trend2);
   
    //
    //
    //
    //
    //
      
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
      
    //
    //
    //
    //
    // 
      
    IndicatorShortName(timeFrameToString(timeFrame)+"  Rsi histo ("+RsiPeriod+")");
 
   return(0);
}
 
//
//
//
//
//
  
int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { UpH1[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame==Period())
   {
      for(i=limit; i>=0; i--)
      {    

         rsi[i]  = iRsi(iMA(NULL,0,1,0,MODE_SMA,Price,i),RsiPeriod,i);
         UpH1[i] = EMPTY_VALUE;
         DnH1[i] = EMPTY_VALUE;
         UpH2[i] = EMPTY_VALUE;
         DnH2[i] = EMPTY_VALUE;
         
   	   if (rsi[i] >  OverboughtLevel)                                                trend1[i] =  1;  
	      if (rsi[i] <  OversoldLevel)                                                  trend1[i] = -1;
	      if (rsi[i] > (OverboughtLevel + OversoldLevel)/2 && rsi[i] < OverboughtLevel) trend2[i] =  1;
	      if (rsi[i] < (OverboughtLevel + OversoldLevel)/2 && rsi[i] > OversoldLevel  ) trend2[i] = -1;
	      
	      if (trend1[i] == 1) UpH1[i] = 1;
         if (trend1[i] ==-1) DnH1[i] = 1;
         if (trend2[i] == 1) UpH2[i] = 1;
         if (trend2[i] ==-1) DnH2[i] = 1;
	      
	    }
      manageAlerts();
      return(0);
   }
      
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
            trend1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Price,RsiPeriod,OverboughtLevel,OversoldLevel,5,y);
            trend2[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Price,RsiPeriod,OverboughtLevel,OversoldLevel,6,y);
            UpH1[i]   = EMPTY_VALUE;
            DnH1[i]   = EMPTY_VALUE;
            UpH2[i]   = EMPTY_VALUE;
            DnH2[i]   = EMPTY_VALUE;
            
            if (trend1[i] == 1) UpH1[i] = 1;
            if (trend1[i] ==-1) DnH1[i] = 1;
            if (trend2[i] == 1) UpH2[i] = 1;
            if (trend2[i] ==-1) DnH2[i] = 1;
            
   }
   manageAlerts();  
   return(0);         
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      
      //
      //
      //
      //
      //
      
      if (alertsOnObOs)
      {
         if (trend1[whichBar] != trend1[whichBar+1])
         {
            if (trend1[whichBar] == 1) doAlert(whichBar,"Overbought or Strong Bulls");
            if (trend1[whichBar] ==-1) doAlert(whichBar,"OverSold or Strong Bears");
         }         
      }
      else
      {
         if (trend2[whichBar] != trend2[whichBar+1])
         {
            if (trend2[whichBar] == 1) doAlert(whichBar,"Trend Bulls");
            if (trend2[whichBar] ==-1) doAlert(whichBar,"Trend Bears");
         }         
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS),"  rsi histo ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"rsi histo"),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}
  
//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//
//

double workRsi[][3];
#define _price  0
#define _change 1
#define _changa 2

//
//
//
//

double iRsi(double price, double period, int shift, int forz=0)
{
   if (ArrayRange(workRsi,0)!=Bars) ArrayResize(workRsi,Bars);
      int    z     = forz*3; 
      int    r     = Bars-shift-1;
      double alpha = 1.0/period; 

   //
   //
   //
   //
   //
   
   workRsi[r][_price+z] = price;
         if (r<period)
            {
               int k; double sum = 0; for (k=0; k<period && (r-k-1)>=0; k++) sum += MathAbs(workRsi[r-k][z+_price]-workRsi[r-k-1][z+_price]);
                  workRsi[r][z+_change] = (workRsi[r][z+_price]-workRsi[0][z+_price])/MathMax(k,1);
                  workRsi[r][z+_changa] =                                         sum/MathMax(k,1);
            }
         else
            {
               double change = workRsi[r][z+_price]-workRsi[r-1][z+_price];
                               workRsi[r][z+_change] = workRsi[r-1][z+_change] + alpha*(        change  - workRsi[r-1][z+_change]);
                               workRsi[r][z+_changa] = workRsi[r-1][z+_changa] + alpha*(MathAbs(change) - workRsi[r-1][z+_changa]);
            }
         if (workRsi[r][z+_changa] != 0)
               return(50.0*(workRsi[r][z+_change]/workRsi[r][z+_changa]+1));
         else  return(50.0);
}


      
	      
	  
	  

